#!/usr/bin/perl

#↑Perlのパス サーバーのマニュアルで確認

$ENV{'TZ'} = "JST-9";

#Cart Z ver.15.1 by CGI Pal

#ver.15--文字コードをUTF8に変更 商品タグ生成機能
#ver.15.1--オプションの在庫の修正

#設置の仕方などはreadme.txtをご覧ください。

#************************ 設定項目 *******************************

$cart='cart.html';		#買い物かごのメイン画面のHTML(スキン)
$enter='enter.html';		#お客様情報入力のためのHTML
$check='check.html';		#入力情報確認のためのHTML(スキン)
$thanks='thanks.html';		#終了画面
$sendmail='/usr/sbin/sendmail';	#sendmailのパス サーバーのマニュアルで調べて記入

$g_log="log/goods.log";		#ログ
$jslog='../goods.js';		#ログ


#-------------- 送料 --------------------

$postage='4';			#送料について 
				#0:計算しない 
				#1:どの商品を何個買っても送料は一定金額 
				#2:全ての商品の送料が同じ 
				#3:商品ごとに違う送料を設定 
				#4:配送方法によって送料を計算

$postage_alt='別途請求';	#$postageを0にして、送料を表示計算しないとき、代わりに文字を表示するときは、''の中に'別途申し請け'などと記入(不要のときは'')
$postage_fix='500';		#$postageを1にしたときは、ここに一定にする送料を記入
$postage_each='500';		#$postageを2にしたときは、ここに一定にする送料を記入

$postage_off='1';		#購入金額が一定以上のときは送料を無料にするときは、1にして、下の$postage_lineで金額指定 $postageの1～4で有効
$postage_line='10000';		#購入金額がこの金額以上なら送料は無料にする
$postage_muryo='1';		#$postage_offを1にしたときに、あと～円の購入で送料が無料に!!と表示するか(0:しない 1:する)


#----------------配送方法--------------------


@deliver=(
'ゆうパック',
'佐川急便',
'クロネコヤマト',
'普通郵便',
'定形外郵便',
'メール便',
);

#使用する配送方法を設定　不要なものは削除するか、#'ゆうパック',のように先頭に#をつける

$deliver_show='0';		#配送方法を消すか (0:消さない 1:消す)
				#配送方法が1つだけに決まっていて、表示する必要のないときは1にしてください

$takuhai='0';			#宅配便は"宅配便"とだけ表示するか (0:表示しない 1:表示する)
				#配送方法にゆうパック、佐川急便、クロネコヤマトのうち1つだけしかない場合に有効

$delivercheck='ゆうパック';	#チェックを入れた状態にしたい配送方法があれば記入

@deli_fix=('普通郵便','メール便');	#$postageを4にしたときに、送料を一定にしたい配送方法があれば記入
@deli_fix_charge=(80,100);		#上の送料


#----------------クール便--------------------

$cool='0';			#クール便
				#0:計算しない 
				#1:クール便の設定のある商品にはクール便料金を加算(クール料金は定額)
				#2:クール便の設定のある商品にはクール便料金を加算(クール料金は重量で計算 $postageが4の場合のみ有効)

$coolcharge='250';		#$coolを1にした場合の料金

#----------------カート画面での送料の計算--------------------

$cartpos='0';			#カート画面で送料計算するか(0:計算しない 1:計算する)$postageが4の場合に有効
$cartposdeli='ゆうパック';	#$cartposを1にした場合は、@deliverに設定した配送方法の中から、カート画面で送料計算する配送方法を記入

#----------------お支払い方法--------------------

@pay=(
'銀行振込',
'郵便振替',
'代金引換',
);

#使用するお支払い方法

$paycheck='銀行振込';		#チェックを入れた状態にしたいお支払い方法があれば記入


#----------------手数料--------------------

$dai_count_on='1';		#代金引換などのときにその手数料を計算する 1:する0:しない

%dai_count=(
'代金引換'=>'250',
'クロネコWEBコレクト'=>'5%',
);

#$dai_count_onを1にしたときはここに各お支払い方法の料金を
#'お支払い方法'=>'その料金',のように設定
#(%にするときは5%などと設定) 
#購入金額が10000円未満は250円、10000円以上20000円未満は350円、20000以上は450円とするときは、
#"10000:20000_250:350:450"と設定

$dai_off='0';			#購入金額が一定以上のときは手数料を無料にするときは、1にして、下の$dai_lineで金額指定
$dai_line='10000';		#購入金額がこの金額以上なら手数料は無料にする


#----------------お支払い方法の固定--------------------

$dai_fix='0';			#特定のお支払い方法に特定の配送方法を固定する(0:しない 1:する)


%dai_attach=(
'銀行振込' => 'ゆうパック',
'代金引換' => 'クロネコヤマト',
'eコレクト' => '佐川急便',
'クロネコWEBコレクト' => 'クロネコヤマト',
);

#$dai_fixを1にしたときはここに"お支払い方法"=>"配送方法"を
#記入する "～のとき"=>"～に固定"


#-------------------各お支払い方法の連絡文------------------------

$tenp_pay='0';			#お支払い方法別に連絡文をつけるか(0:つけない 1:つける)
				#1にしたときは下に各お支払い方法の連絡文を設定($xxxx=<<'COM';とCOMの間に記入)

$paymsg_bank=<<'COM';
銀行振込のときの連絡文

COM

$paymsg_yu=<<'COM';
郵便振替のときの連絡文

COM

$paymsg_dai=<<'COM';
代金引換のときの連絡文

COM

$paymsg_e=<<'COM';
eコレクトのときの連絡文

COM

$paymsg_kuro=<<'COM';
クロネコWEBコレクトのときの連絡文

COM

$paymsg_teikeigai=<<'COM';

COM

$paymsg_card=<<'COM';

COM

#-------------------クロネコWEBコレクト用設定------------------------

#クロネコWEBコレクトを使うときは必ず注文番号の設定の$idを1か2にすること(なるべく2)

$trader_code='012345678';	#加盟店コード

#-------------------注文・確認メールの設定------------------------

#確認メールの前後に表示するメッセージを記入します。
#前の文は$email_style1に、後の文は$email_style2に記入

$email_style1=<<'EOM';
ご注文ありがとうございます。
送信されたメールの内容は以下のようになっておりますので
ご確認ください。
EOM

$email_style2=<<'EOM';
どうもありがとうございました。

---------------------------
hoge@ne.jp
http://hoge.ne.jp
---------------------------
EOM

$shop='ショップ名';					#ショップ名を設定
$chk_mailsub='ご注文ありがとうございます。';		#確認メールの件名を設定
$rcpt_mailsub='注文メール';				#ショップに届く件名
$checkmail='1';						#確認メールを送るか(0送らない:1:送る)

$mailto='****@***.****';	#注文のメールを受け取る人(あなた)のメールアドレス
$mailto2='';			#注文メールをもう一つ送るときは''の中に記入

#----------------ラッピング------------------------

$wrapping='0';		#ラッピングを計算するか(0:しない 1:する)
$wrap_charge='100';	#ラッピングの費用
$wrap_off='0';		#購入金額が一定以上ならラッピング無料にする(0:しない 1:する)
$wrap_off_line='1000';	#$wrap_offを設定したときはここで無料にする金額を設定

#※ラッピングの表示の仕方はreadmeを読んでください。

#---------------------csvファイル-------------------------------

$csv='0';		#csvファイルをメールに添付する 1:する0:しない
$csvfile='data';	#添付するcsvファイルの名前

#---------------------注文番号-------------------------------

$id='2';			#注文番号の発行 0:しない 1:数字の通し番号(例:00001) 2:年+月+日+日のカウント 3:適当な番号
$digit='5';			#注文番号の桁数($idを1にしたときのみ)
$countlog='log/count.log';	#カウントを記録するファイル
$id_title='1';			#注文番号をメールのタイトルにつけるか 0:つけない 1:つける
$id_filename='0';		#cvsファイルの名前を注文番号にするか 0:しない 1:する

#---------------------割引-------------------------------

$waribiki='0';		#割引をする(0:しない 1:する)
$wariritu='10';		#割引率(%)

#------------------- その他 -------------------------------

$pd='rUiITX9c';		#個人情報のクッキーを暗号化するパスワード(必ず変更すること。何文字でもいいですが半角英数字で8文字以上にしてください。)
$c_valid='365';		#購入者のクッキーを保存する日数
$maxsize='100000';	#post送信の際のバイトの上限
$wh='25';		#カート画面での画像の縦横サイズ
$viewmode='0';		#購入する前のクッキーがない状態でカゴを見るを押したときの動作 0:エラー表示 1:カート画面を表示


$dollar='0';		#0:日本円 1:外貨表示
$yen='0';		#円の表示 0:円 1:\
$zei='2';		#税の表示方式(0:旧 1:総額表示(税抜価格を元に税額を出す) 2:総額表示(税込価格を元に税額を出す))
			#1にした場合は、カタログページの<input type="hidden" name="price" value="値段">には
			#税抜きの価格を記入すること。
			#2にした場合は、カタログページの<input type="hidden" name="price" value="値段">には
			#税込みの価格を記入すること。
$tansu='1';		#いわゆる端数処理について(0:個々の商品に税をかけて少数点以下切り捨て 1:小計にまとめて税をかけて小数点以下切り捨て)
			#1にすると余分に税金を払うことになります。
$taxrate='5';		#消費税率(%) 税をかけないときは0にする
$tmplog='log/tmp.log';	#商品を一時的に記録するファイル
$lockfile='log/lock';	#ロックファイル(パーミッション606)
$ssl='0';		#SSLを使うか(0:使わない 1:使う)
$zaiko='1';		#在庫管理をする(0:しない 1:する)
$operror='1';		#サイズなどのオプションを選択していないときにエラーを出すか

$mailpl='lib/mail.pl';

#**************************** 設定はここまで **************************************

unless(-e 'lib/functions.pl'){
	&error("lib/functions.plがありません。");
}
require 'lib/functions.pl';


%PREF=(
"1" => '北海道',
"2" => '青森県',
"3" => '岩手県',
"4" => '秋田県',
"5" => '宮城県',
"6" => '山形県',
"7" => '福島県',
"8" => '茨城県',
"9" => '栃木県',
"10" => '群馬県',
"11" => '埼玉県',
"12" => '千葉県',
"13" => '東京都',
"14" => '神奈川県',
"15" => '新潟県',
"16" => '富山県',
"17" => '石川県',
"18" => '福井県',
"19" => '長野県',
"20" => '山梨県',
"21" => '静岡県',
"22" => '愛知県',
"23" => '岐阜県',
"24" => '三重県',
"25" => '滋賀県',
"26" => '京都府',
"27" => '大阪府',
"28" => '兵庫県',
"29" => '奈良県',
"30" => '和歌山県',
"31" => '鳥取県',
"32" => '島根県',
"33" => '岡山県',
"34" => '広島県',
"35" => '山口県',
"36" => '香川県',
"37" => '徳島県',
"38" => '愛媛県',
"39" => '高知県',
"40" => '福岡県',
"41" => '大分県',
"42" => '佐賀県',
"43" => '長崎県',
"44" => '宮崎県',
"45" => '熊本県',
"46" => '鹿児島県',
"47" => '沖縄県',
);



if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>$maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}


if($buff){
	&Dcd;
}

sub Dcd{
my($name,$value,$pair,@pairs);
@pairs=split(/&/,$buff);
foreach $pair (@pairs){
	($name,$value)=split(/=/,$pair);
	$value=~tr/+/ /;
	$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
	$value=~s/&/＆/g;
	$value=~s/</＜/g;
	$value=~s/>/＞/g;
	$value=~s/"/”/g;
	$value=~s/'/’/g;
	$value=~s/,//g;
	if($name eq "message"){
		$value=~s/\x0D\x0A/\n/g;
		$value=~s/\x0D/\n/g;
		$value=~s/\x0A/\n/g;
	}
	else{
		$value=~s/\x0D\x0A//g;
		$value=~s/\x0D//g;
		$value=~s/\x0A//g;
	}
	$FORM{$name}=$value;
}
}

$c_name="cartz";
$angoc_name="c_encoded";

&GetCookie;

if($FORM{'mode'} eq "del"){
	&Del;
}
elsif($FORM{'mode'} eq "clear"){
	&Clear;
}
elsif($FORM{'mode'} eq "regist"){
	&Regist;
}
elsif($FORM{'mode'} eq "view"){
	&View;
}
elsif($FORM{'mode'} eq "modify"){
	&Modify;
}
elsif($FORM{'mode'} eq "enter"){
	&Enter;
}
elsif($FORM{'mode'} eq "check"){
	&Check;
}
elsif($FORM{'mode'} eq "order"){
	&Order;
}
elsif($FORM{'mode'} eq "back"){
	&Back;
}
else{
	if($ENV{'REQUEST_METHOD'} eq "POST" && $ENV{'CONTENT_LENGTH'} == 0){	
		&error("エラーが発生しました。ブラウザの更新ボタンを押すと送信されます。","r");
	}
	else{
		&error("cart.cgiは直接起動できません。カタログページから呼び出してください。");
	}
}


sub SetCookie{
my($cook,$name);
$cook=$_[0];
$name=$_[1];
$cook =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
$cook =~ tr/ /+/;
print "Set-Cookie: $name=$cook;\n";

}


sub View{
my($_sessid,$ref);

if($DUMMY{$c_name}){
	($_sessid)=split(/<>/,$DUMMY{$c_name});
	($ref)=&OpenData($_sessid);
}
else{
	if(!$viewmode){
		&error("現在カートには商品は入っていません。");
	}
}

$viewflag=1;

&Cart($ref,$_sessid);

}


sub Regist{
my(
$flag,@new,$ref,$num,$name,$price,$amount,$pt,$image,$pack,$weight,$cook,@tmp,$tmp,$tmp2,
$opline,$z_flag,$nocookie,$code,$time,@alltmp,$checkflag,$stock,$op,$line,$_sessid,$i,$idx,
$page,$no_s,$no_p,$no_w,$cl,$dum,
);

if($operror){
	$i=0;
	foreach(@opvalue){
		if($_ eq ""){
			if($opnamearray[$i] eq ""){
				$tmp="オプション";
			}
			else{
				$tmp=$opnamearray[$i];
			}
			&error("$tmpが選択されていません。");
		}
		$i++;
	}

}


if($FORM{'op1'} || $FORM{'op2'}){
	if($FORM{'op1'}){
		if($FORM{'op1'}=~/:/){
			($FORM{'op1'},$FORM{'price'})=split(/:/,$FORM{'op1'});
		}
		push @tmp,$FORM{'op1'};
	}
	if($FORM{'op2'}){
		push @tmp,$FORM{'op2'};
	}
	$opline=join(":",@tmp);
	$tmp2=join("",@tmp);
	$FORM{'number'}=$FORM{'number'}."__$tmp2";
}


if($FORM{'stock'} ne ""){
	$z_flag=1;
	if($FORM{'stock'}==0){
		&error("大変申し訳ありません。この商品は在庫が切れております。","c");
	}
	if($FORM{'amount'}>$FORM{'stock'}){
		&error("注文個数が在庫数より多くなっています。在庫数は$FORM{'stock'}です。","c");
	}
}

if($FORM{'opstock'} ne ""){
	$z_flag=2;
	if($FORM{'opstock'} == 0){
		&error("大変申し訳ありません。$FORM{'name'}の$FORM{'opname'}は在庫が切れております。","c");
	}
	if($FORM{'amount'} > $FORM{'opstock'}){
		&error("$FORM{'name'}の$FORM{'opname'}の注文個数が在庫数より多くなっています。在庫数は$FORM{'opstock'}です。","c");
	}
	$FORM{'stock'}=$FORM{'opstock'};
}

$nocookie=0;
if($DUMMY{$c_name}){
	($_sessid)=split(/<>/,$DUMMY{$c_name});
	($ref,$checkflag)=&OpenData($_sessid);
	if(!$checkflag){
		$nocookie=1;
	}
}
else{
	$nocookie=1;
}


if(!$FORM{'amount'}){
	$FORM{'amount'}=1;
}
$flag=0;
$idx=0;
foreach(@{$ref}){
	($num,$name,$price,$amount,$pt,$image,$weight,$pack,$stock,$page,$op,$no_s,$no_p,$no_w,$cl)=split(/,/,$_);
	if($num eq $FORM{'number'}){
		$flag=1;
		$amount=$amount+$FORM{'amount'};
		if($z_flag==1){
			if($FORM{'stock'} < $amount && $zaiko){
				&error("$nameの注文個数が在庫数より多くなっています。在庫数は$FORM{'stock'}です。","c");
			}
		}
		elsif($z_flag==2){
			if($FORM{'stock'} < $amount && $zaiko){
				&error("$nameの$opの注文個数が在庫数より多くなっています。在庫数は$FORM{'stock'}です。","c");
			}
		}
		$_="$num,$name,$price,$amount,$pt,$image,$weight,$pack,$stock,$page,$op,$no_s,$no_p,$no_w,$cl";
	}
	$new[$idx]=$_;
	$idx++;
}
if(!$flag){
	$new[$idx]="$FORM{'number'},$FORM{'name'},$FORM{'price'},$FORM{'amount'},$FORM{'postage'},$FORM{'image'},$FORM{'weight'},$FORM{'pack'},$FORM{'stock'},$dum,$opline,$FORM{'no_s'},$FORM{'no_p'},$FORM{'no_w'},$FORM{'cool'}";
}

&filelock;


$cook=join('&',@new);
if($nocookie){
	$code=&Enc;
	$_sessid=$code;
	$tmp=$code."<>".$FORM{'page'};
	&SetCookie($tmp,$c_name);
	$time=time();
	$line="$code<>$time<>$FORM{'page'}<>$cook<>\n";
	unless(open(TMP,$tmplog)){
		&error("$tmplogが開けません");
	}
	@alltmp=<TMP>;
	close TMP;
	unshift @alltmp,$line;
	unless(open(TMP,">$tmplog")){
		&error("$tmplogに書き込めません");
	}
	print TMP @alltmp;
	close TMP;
}
else{
	($code)=split(/<>/,$DUMMY{$c_name});
	$tmp=$code."<>".$FORM{'page'};
	&SetCookie($tmp,$c_name);
	&WriteData($_sessid,$cook);
}
if($lockflag==1){
	close LOCK;
}

&Cart(\@new,$_sessid);

}

sub Enc{
my(@saltset,$salt,$newcode,@a,$tail,$key,$sal);
@saltset=('a'..'z','A'..'Z','0'..'9');
srand(time^$$);
$salt=$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))];
$key=$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))];
eval{$newcode=crypt($key,$salt);};
if($@){
	&error("暗号化の関数がサポートされていないのでこのサーバーでは使えません。");
}
if($newcode=~/^\$1\$/){
	$newcode=crypt($key,'$1$');
}
if(!$_[1]){
	@a=('a'..'z','A'..'Z','0'..'9');
	$tail=$a[int(rand(@a))].$a[int(rand(@a))];
	$newcode.=$tail;
	$newcode=~s/\.//g;
	$newcode=~s/\///g;
}
return $newcode;
}


sub Cart{
my(
$skinline,$head,$dummy,$footer,
$goods,$total,$subtotal,$a_total,$postage_all,$tmp,$muryo,
@new,$tax_all,$muryo_c,$postage_line_c,
$tax,$postage_all_c,$tax_c,$subtotal_c,$total_c,
$page,$ref,$_sessid,$weight_all,$pack_all,$wari,$d,
$g_line_ref,$subtotal_o,$wari_c,$ar,$deliver,$areaselect,@keys,
$s,$subtotal_o_c,
);

$ref=$_[0];
$_sessid=$_[1];

unless(open(HTML, $cart)){
	&error("$cartが開けません。ファイル名を確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);
($head,$dummy) = split(/<!--goodsstart-->/, $skinline);
if($head eq ""){
	&error("$cartに&lt;!--goodsstart--&gt;が書かれていません。");
}
($goods,$footer) = split(/<!--goodsend-->/, $dummy);
if($goods eq ""){
	&error("$cartに&lt;!--goodsend--&gt;が書かれていません。");
}

$page=&GetBack;

$head=~s/\/\/--back--/u="$page";/;

$subtotal=0;
$a_total=0;
$postage_all=0;
$tax=0;
$tax_all=0;
$total=0;

if(${$ref}[0]){
	($subtotal,$a_total,$tax_all,$postage_all,$weight_all,$pack_all,$wari,$d,$d,$d,$g_line_ref)=&GoodsCal($goods,$ref);

	$subtotal_o=$subtotal;
	if($waribiki){#?
		$subtotal-=$wari;
		$wari_c=&Comma($wari);
	}
	($tax,$total)=&Tax($subtotal,$tax_all);
	if($postage != 4){
		($total,$postage_all)=&PostageCal($total,$subtotal,$postage_all,$a_total,$cool_count);
	}
	else{
		if($cartpos){#?
			if($FORM{'pref'}){
				$ar=$FORM{'pref'};
			}
			else{
				$ar=13;
			}
			$deliver=$cartposdeli;
			if($a_total != $no_s_count){
				($total,$postage_all)=&PostageCal2($total,$subtotal,$weight_all,$pack_all,$deliver,$ar,$cool_count,$a_total);
			}
			else{
				$postage_all=0;
			}
			$areaselect=" <select name=\"pref\" onchange=\"CartPos(this)\">\n";
			@keys=keys %PREF;
			@keys=sort{$a<=>$b}@keys;
			foreach(@keys){
				if($_ == $ar){
					$s=" selected";
				}
				else{
					$s="";
				}
				$areaselect.="<option value=\"$_\"$s>$PREF{$_}</option>\n";
			}
			$areaselect.="</select>\nの場合";
			$footer =~ s/<!--cartpos-->/$areaselect/;
		}

	}
	$postage_all_c=&Comma($postage_all);
	$muryo=$postage_line-$subtotal;
	if(!$postage){
		if($postage_alt){
			$footer =~ s/<!--postage-->/$postage_alt/;
		}
		else{
			$footer =~ s/<!--postage-->/$postage_all_c/;
		}
	}
	elsif($postage == 4 && !$cartpos){
		$footer =~ s/<!--postage-->/後で計算/;
	}
	else{
		$footer =~ s/<!--postage-->/$postage_all_c/;
	}
	if($postage && $postage_muryo){
		if($muryo > 0){
			$muryo_c=&Comma($muryo);
			$tmp="<br>※あと$muryo_cのお買い物で送料が無料に!!";
		}
		else{
			$postage_line_c=&Comma($postage_line);
			$tmp="<br>※$postage_line_c以上のお買い物ですので送料が無料!!";
		}
		$footer =~ s/<!--muryo-->/$tmp<br><br>/;
	}
	$footer =~ s/#sessid/$_sessid/;
	$footer =~ s/#pref/$ar/;
}
else{
	$footer =~ s/<!--enter-->.*?<!--\/enter-->//is;
	$footer =~ s/<!--clear-->.*?<!--\/clear-->//is;
	$footer =~ s/<!--modify-->.*?<!--\/modify-->//is;
	$footer =~ s/#sessid//;
	$footer =~ s/#pref//;
	$postage_all_c=&Comma($postage_all);
	$footer =~ s/<!--postage-->/$postage_all_c/;
	if($viewmode && !$DUMMY{$c_name}){
		$footer =~ s/<!--back-->.*?<!--\/back-->//is;
	}
}

$tax_c=&Comma($tax);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$total_c=&Comma($total);
$footer =~ s/<!--a_total-->/$a_total個/;

$footer =~ s/<!--tax-->/$tax_c/;
$footer =~ s/<!--total-->/$total_c/;

if(!$waribiki){
	$footer =~ s/<!--subtotal-->/$subtotal_c/;
	$footer =~ s/<!--waribiki-->.*?<!--\/waribiki-->//is;
	$footer =~ s/<!--warigo-->.*?<!--\/warigo-->//is;
}
else{
	$subtotal_o_c=&Comma($subtotal_o);
	$footer =~ s/<!--subtotal-->/$subtotal_o_c/;
	$footer =~ s/<!--subtotal_w-->/$subtotal_c/;
	$footer =~ s/<!--wari-->/-$wari_c/;
	$footer =~ s/<!--ritu-->/$wariritu/;
}

print <<EOM;
P3P: CP="UNI CUR OUR"
Content-type: text/html

EOM

print $head;
print ${$g_line_ref};
print $footer;
exit;
}


sub SetCookieAn{
my($cook,$name,$date_gmt);
$cook=$_[0];
$name=$_[1];
$date_gmt=&settime;

print "Set-Cookie: $name=$cook; expires=$date_gmt\n";
}

sub CookieDel{
my($name);
$name=$_[0];
print "Set-Cookie: $name=\n";
}

sub GetCookie{
	my($name,$value,$pair,@pairs,$cookies);
	$cookies=$ENV{'HTTP_COOKIE'};
	@pairs=split(/;/,$cookies);
	foreach $pair(@pairs){
		($name, $value)=split(/=/,$pair);
		$name=~s/ //g;
		$DUMMY{$name}=$value;
	}
	$DUMMY{$c_name} =~ s/\+/ /g;
	$DUMMY{$c_name}=~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;

}

sub Del{
my(
@new,$cook,$delnum,$num,
$_sessid,$ref,$idx
);

if(!$DUMMY{$c_name}){
	&error("クッキーが無効になっているのでショッピングカートは使えません。");
}
$delnum=$FORM{'id'};

($_sessid)=split(/<>/,$DUMMY{$c_name});
($ref)=&OpenData($_sessid);
$idx=0;
foreach(@{$ref}){
	($num)=split(/,/,$_);
	if($delnum ne $num){
		$new[$idx]=$_;
		$idx++;
	}
}
&filelock;

$cook=join('&',@new);
&WriteData($_sessid,$cook);
if($lockflag == 1){
	close LOCK;
}
&Cart(\@new,$_sessid);

}

sub Clear{
my($_sessid,@new);
if(!$DUMMY{$c_name}){
	&error("クッキーが無効になっているのでショッピングカートは使えません。");
}

&filelock;

($_sessid)=split(/<>/,$DUMMY{$c_name});
&WriteData($_sessid,"");
if($lockflag == 1){
	close LOCK;
}

@new=();
&Cart(\@new,$_sessid);

}

sub Modify{
my(@new,$cook,@goodsnum,$n_line,$n_line_d,$flag,
$num,$name,$price,$amount,$pt,$image,$weight,
@keylist,$line,$pack,$stock,$op,$_sessid,$ref,$idx,
$dum,$no_s,$no_p,$no_w,$cl
);

if(!$DUMMY{$c_name}){
	&error("クッキーが無効になっているのでショッピングカートは使えません。");
}
@keylist=keys %FORM;
foreach(@keylist){
	if($_=~/^mdfy_/){
		push(@goodsnum,$_);
	}
}

($_sessid)=split(/<>/,$DUMMY{$c_name});
($ref)=&OpenData($_sessid);
$idx=0;
foreach $line(@{$ref}){
	$flag=0;
	($num,$name,$price,$amount,$pt,$image,$weight,$pack,$stock,$dum,$op,$no_s,$no_p,$no_w,$cl)=split(/,/,$line);
	foreach $n_line(@goodsnum){
		if($FORM{$n_line}=~/\D/){
			&error("個数は数字を入力してください。");
		}
		$n_line_d=$n_line;
		$n_line_d =~s/\+/ /g;
		$n_line_d=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		$n_line_d=~s/^mdfy_//;
		if($num eq $n_line_d){
			if($amount != $FORM{$n_line}){
				if($FORM{$n_line} == 0){
 					$flag=1;
					last;
				}
				else{
					if($stock ne ""){
						if($stock < $FORM{$n_line} && $zaiko){
							&error("$nameの個数が在庫数より多くなっています。$nameの在庫数は$stockです。","b");
						}
					}
					$line="$num,$name,$price,$FORM{$n_line},$pt,$image,$weight,$pack,$stock,$dum,$op,$no_s,$no_p,$no_w,$cl";
				}
  			}
		}

	}
	if(!$flag){
		$new[$idx]=$line;
		$idx++;
	}
}

&filelock;

$cook=join('&',@new);

&WriteData($_sessid,$cook);
if($lockflag==1){
	close LOCK;
}

&Cart(\@new,$_sessid);

}

sub GetBack{
my(@all,$page);
@all=split(/<>/,$DUMMY{$c_name});
if($FORM{'mode'} eq "regist"){
	$page=$FORM{'page'};
}
else{
	$page=$all[1];
}

return $page;
}

sub settime{
my($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg,@month,@week,$date_gmt);
($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg)=gmtime(time+$c_valid*24*60*60);
@month=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date_gmt=sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",$week[$wdayg],$mdayg,$month[$mong],$yearg+1900,$hourg,$ming,$secg);
return $date_gmt;
}


sub Enter{

my(
$tmp,$skinline,$area,
$cook,$ref,$s,$pr,$footer,$a_total,$total,
$subtotal,$weight_all,$pack_all,$ar,$postage_all,$postage_all_c,
$tax_c,$tax,$subtotal_c,$subtotal_o_c,$wari_c,
$name1,$name2,$kana1,$kana2,$postal,$pref,$address,$address2,$tel,$email,$email2,
$payline,$n,$ck,$dline,$count,$flag,$v,$deliline,$head,$dummy,$goods,$tax_all,
$d,$wari,$g_line_ref,$deliver,$total_c,$subtotal_o,
);

($ref)=&OpenData($FORM{'sessid'});

unless(open(HTML, $enter)){&error("$enterが開けません。ファイル名を確認してください。");}
$skinline = join('',<HTML>);
close(HTML);

$skinline=~s/#sessid/$FORM{'sessid'}/;

($head,$dummy) = split(/<!--goodsstart-->/, $skinline);
if($head eq ""){
	&error("$enterに&lt;!--goodsstart--&gt;が書かれていません。");
}
($goods,$footer) = split(/<!--goodsend-->/, $dummy);
if($goods eq ""){
	&error("$enterに&lt;!--goodsend--&gt;が書かれていません。");
}

$subtotal=0;
$a_total=0;
$postage_all=0;
$tax_all=0;
$tax=0;
$total=0;
($subtotal,$a_total,$tax_all,$postage_all,$weight_all,$pack_all,$wari,$d,$d,$d,$g_line_ref)=&GoodsCal($goods,$ref);
$subtotal_o=$subtotal;
if($waribiki){
	$subtotal-=$wari;
	$wari_c=&Comma($wari);
}
($tax,$total)=&Tax($subtotal,$tax_all);
if($postage != 4){
	($total,$postage_all)=&PostageCal($total,$subtotal,$postage_all,$a_total,$cool_count);
}
else{
	if($cartpos && $FORM{'pref'}){
		$ar=$FORM{'pref'};
		$deliver=$cartposdeli;
		$s='('.$PREF{$ar}."の場合".')';
		$footer =~ s/<!--cartpos-->/$s/;
		if($a_total != $no_s_count){
			($total,$postage_all)=&PostageCal2($total,$subtotal,$weight_all,$pack_all,$deliver,$ar,$cool_count,$a_total);
		}
		else{
			$postage_all=0;
		}
	}
}
$postage_all_c=&Comma($postage_all);
if(!$postage){
	if($postage_alt){
		$footer =~ s/<!--postage-->/$postage_alt/;
	}
	else{
		$footer =~ s/<!--postage-->/$postage_all_c/;
	}
}
elsif($postage == 4 && !$cartpos){
	$footer =~ s/<!--postage-->/後で計算/;
}

else{
	$footer =~ s/<!--postage-->/$postage_all_c/;
}


$tax_c=&Comma($tax);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$total_c=&Comma($total);
$footer =~ s/<!--a_total-->/$a_total個/;

$footer =~ s/<!--tax-->/$tax_c/;
$footer =~ s/<!--total-->/$total_c/;

if(!$waribiki){
	$footer =~ s/<!--subtotal-->/$subtotal_c/;
	$footer =~ s/<!--waribiki-->.*?<!--\/waribiki-->//is;
	$footer =~ s/<!--warigo-->.*?<!--\/warigo-->//is;
}
else{
	$subtotal_o_c=&Comma($subtotal_o);
	$footer =~ s/<!--subtotal-->/$subtotal_o_c/;
	$footer =~ s/<!--subtotal_w-->/$subtotal_c/;
	$footer =~ s/<!--wari-->/-$wari_c/;
	$footer =~ s/<!--ritu-->/$wariritu/;
}

$tmp=$DUMMY{$angoc_name};

if($tmp){
	if($pd eq ""){
		&error("パスワードが設定されていません。");
	}

	$tmp=&Decrypt($tmp);

	($name1,$name2,$kana1,$kana2,$postal,$pref,$address,$address2,$tel,$email,$email2)=split(/,/,$tmp);

	$footer=~s/#name1/$name1/;
	$footer=~s/#name2/$name2/;
	$footer=~s/#kana1/$kana1/;
	$footer=~s/#kana2/$kana2/;
	$footer=~s/#email/$email/;
	$footer=~s/#email2/$email/;
	$footer=~s/#postal/$postal/;
	$footer=~s/#address/$address/;
	$footer=~s/#address2/$address2/;
	$footer=~s/#tel/$tel/;
	$footer=~s/value="$area"/value="$area" selected/;
	if($pref){
		$footer=~s/value="$pref"/value="$pref" selected/;
	}

}
else{
	$footer=~s/#name1//;
	$footer=~s/#name2//;
	$footer=~s/#kana1//;
	$footer=~s/#kana2//;
	$footer=~s/#postal//;
	$footer=~s/#address//;
	$footer=~s/#address2//;
	$footer=~s/#tel//;
	$footer=~s/#email//;
	$footer=~s/#email2//;
}

$payline="";
$n=@pay;
foreach(@pay){
	if($n == 1){
		$ck=" checked";
	}
	else{
		if($_ eq $paycheck){
			$ck=" checked";
		}
		else{
			$ck="";
		}
	}
	$payline.="<input type=\"radio\" name=\"pay\" value=\"$_\"$ck>$_ ";
}
$footer=~s/<!--pay-->/$payline/;



$deliline="";
$n=@deliver;
if($n == 1 && $deliver_show){
	$dline="<input type=\"hidden\" name=\"deliver\" value=\"$deliver[0]\">";
	$footer=~s/<!--delitmp-->/$dline/;

}
else{
	$count=0;
	$flag=0;
	foreach(@deliver){
		if($deliver[0] eq '佐川急便' || $deliver[0] eq 'ゆうパック' || $deliver[0] eq 'クロネコヤマト'){
			$count++;
		}
	}
	
	if($count == 1 && $takuhai){
		$flag=1;
	}
	foreach(@deliver){
		$v=$_;
		if($flag){
			if($_ eq '佐川急便' || $_ eq 'ゆうパック' || $_ eq 'クロネコヤマト'){
				$v='宅配便';
			}
		}
		$ck="";
		if($n == 1){
			$ck=" checked";
		}
		else{
			if($delivercheck && $_ eq $delivercheck){
				$ck=" checked";
			}
		}
		$deliline.="<input type=\"radio\" name=\"deliver\" value=\"$_\"$ck>$v ";
	}
}


$footer=~s/<!--deli-->/$deliline/;


print <<EOM;
P3P: CP="UNI CUR OUR"
Content-type: text/html

EOM

print $head;
print ${$g_line_ref};
print $footer;

exit;

}


sub Check{
my(
$skinline,$head,$dummy,$goods,$m_tmp,$info,$total,$subtotal,$a_total,$postage_all,
$weight_all,$ar,
$dai_charge,$postage_all_c,$total_c,$subtotal_c,$tax_c,$tax_all,$dai_name,
$footer,$tax,$dai_charge_c,$tmp,$tmp2,
$err,$pack_all,$wrap_charge_c,$ref,$wari,$d,$g_line_ref,
$subtotal_o,$wari_c,$subtotal_o_c,$tb,
);

$err="";
if($FORM{'name1'} eq ""){
	$err.='お名前が入力されていません。<br>';
}
if($FORM{'kana1'} eq ""){
	$err.='フリガナが入力されていません。<br>';
}
if($FORM{'postal'} eq ""){
	$err.='郵便番号が入力されていません。<br>';
}
if($FORM{'pref'} eq ""){
	$err.='ご住所の都道府県が選択されていません。<br>';
}
if($FORM{'address'} eq ""){
	$err.='ご住所が入力されていません。<br>';
}

if($FORM{'tel'} eq ""){
	$err.='お電話番号が入力されていません。<br>';
}
if($FORM{'email'} eq ""){
	$err.='メールアドレスが入力されていません。<br>';
}
if($FORM{'email'} !~ /^([a-zA-Z0-9\.\-\/_]{1,})@([a-zA-Z0-9\.\-\/_]{1,})\.([a-zA-Z0-9\.\-\/_]{1,})$/){
	$err.='メールアドレスが正しくありません。全角で入力されていないか等確認してください。<br>';
}
if($FORM{'haisou'}){
	if($FORM{'name_rcpt1'} eq ""){
		$err.='お届け先のお名前が入力されていません。<br>';
	}
	if($FORM{'kana_rcpt1'} eq ""){
		$err.='お届け先のフリガナが入力されていません。<br>';
	}
	if($FORM{'postal_rcpt'} eq ""){
		$err.='お届け先の郵便番号が入力されていません。<br>';
	}
	if($FORM{'pref_rcpt'} eq ""){
		$err.='お届け先のご住所の都道府県が選択されていません。<br>';
	}
	if($FORM{'address_rcpt'} eq ""){
		$err.='お届け先のご住所が入力されていません。<br>';
	}
	if($FORM{'tel_rcpt'} eq ""){
		$err.='お届け先の電話番号が入力されていません。<br>';
	}
}


if($err){
	&error($err)
}

if($dai_fix){
	$tmp=$FORM{'pay'};
	$tmp2=$dai_attach{$tmp};
	if($tmp2){
		$FORM{'deliver'}=$tmp2;
	}
}

($ref)=&OpenData($FORM{'sessid'});

unless(open(HTML, $check)){&error("$checkが開けません。ファイル名を確認してください。");}
$skinline = join('',<HTML>);
close(HTML);

($head,$dummy) = split(/<!--goodsstart-->/, $skinline);
if($head eq ""){
	&error("$checkに&lt;!--goodsstart--&gt;が書かれていません。");
}
undef $skinline;
($goods,$footer) = split(/<!--goodsend-->/, $dummy);
if($goods eq ""){
	&error("$checkに&lt;!--goodsend--&gt;が書かれていません。");
}



$subtotal=0;
$a_total=0;
$postage_all=0;
$tax_all=0;
$tax=0;
$total=0;
$weight_all=0;

($subtotal,$a_total,$tax_all,$postage_all,$weight_all,$pack_all,$wari,$d,$d,$d,$g_line_ref)=&GoodsCal($goods,$ref);
$subtotal_o=$subtotal;
if($waribiki){
	$subtotal-=$wari;
	$wari_c=&Comma($wari);
}
($tax,$total)=&Tax($subtotal,$tax_all);
if($postage != 4){
	($total,$postage_all)=&PostageCal($total,$subtotal,$postage_all,$a_total,$cool_count);
}
else{
	$ar=$FORM{'pref_rcpt'} || $FORM{'pref'};
	($total,$postage_all)=&PostageCal2($total,$subtotal,$weight_all,$pack_all,$FORM{'deliver'},$ar,$cool_count,$a_total);

}
if($FORM{'wrapping'} eq "yes"){
	($wrap_charge,$total)=&Wrap($total,$subtotal);
}
$dai_charge=0;
if($dai_count_on){
	($dai_charge,$total,$dai_name)=&Dai($FORM{'pay'},$total,$subtotal);
}
else{
	$footer =~ s/<!--tesu-->.*?<!--\/tesu-->//is;

}
$postage_all_c=&Comma($postage_all);
$tax_c=&Comma($tax);
$dai_charge_c=&Comma($dai_charge);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$total_c=&Comma($total);


$footer =~ s/<!--a_total-->/$a_total個/;

if(!$postage){
	if($postage_alt){
		$footer =~ s/<!--postage-->/$postage_alt/;
	}
	else{
		$footer =~ s/<!--postage-->/$postage_all_c/;
	}
}
else{
	$footer=~ s/<!--postage-->/$postage_all_c/;
}

if(!$waribiki){
	$footer =~ s/<!--warigo-->.*?<!--\/warigo-->//is;
	$footer =~ s/<!--subtotal-->/$subtotal_c/;
	$footer =~ s/<!--waribiki-->.*?<!--\/waribiki-->//is;
}
else{
	$subtotal_o_c=&Comma($subtotal_o);
	$footer =~ s/<!--subtotal-->/$subtotal_o_c/;
	$footer =~ s/<!--subtotal_w-->/$subtotal_c/;
	$footer =~ s/<!--wari-->/-$wari_c/;
	$footer =~ s/<!--ritu-->/$wariritu/;

}


$footer =~ s/<!--tax-->/$tax_c/;
$footer =~ s/<!--total-->/$total_c/;
$footer =~ s/<!--dai-->/$dai_name/;
$footer =~ s/<!--charge-->/$dai_charge_c/;
$footer =~ s/<!--name1-->/$FORM{'name1'}/;
$footer =~ s/<!--name2-->/$FORM{'name2'}/;
$footer =~ s/<!--kana1-->/$FORM{'kana1'}/;
$footer =~ s/<!--kana2-->/$FORM{'kana2'}/;
$footer =~ s/<!--postal-->/$FORM{'postal'}/;
$footer =~ s/<!--pref-->/$PREF{$FORM{'pref'}}/;
$footer =~ s/<!--address-->/$FORM{'address'}/;
$footer =~ s/<!--address2-->/$FORM{'address2'}/;
$footer =~ s/<!--email-->/$FORM{'email'}/;
$footer =~ s/<!--tel-->/$FORM{'tel'}/;
$footer =~ s/<!--pay-->/$FORM{'pay'}/;
$footer =~ s/<!--deliver-->/$FORM{'deliver'}/;


if($FORM{'wrapping'} eq "yes"){
	$wrap_charge_c=&Comma($wrap_charge);
	$footer =~ s/<!--wrapping-->/$wrap_charge_c/;
}
elsif($FORM{'wrapping'} eq "no"){
	$footer =~ s/<!--wrapping-->/なし/;
}
if($FORM{'deliver_day'} eq "on"){
	$footer =~ s/<!--date-->/$FORM{'month'}月$FORM{'day'}日/;
}
else{
	$footer =~ s/<!--date-->/指定しない/;
}
if($FORM{'deliver_time'} eq "on"){
	$footer =~ s/<!--time-->/$FORM{'time'}/;
}
else{
	$footer =~ s/<!--time-->/指定しない/;
}
if($FORM{'message'}){
	$m_tmp=$FORM{'message'};
	$FORM{'message'}=~s/\n/<br>/g;
	$footer =~ s/<!--message-->/$FORM{'message'}/;
}


if($FORM{'name_rcpt1'}){
	$footer =~ s/<!--name_rcpt1-->/$FORM{'name_rcpt1'}/;
	$footer =~ s/<!--name_rcpt2-->/$FORM{'name_rcpt2'}/;
	$footer =~ s/<!--kana_rcpt1-->/$FORM{'kana_rcpt1'}/;
	$footer =~ s/<!--kana_rcpt2-->/$FORM{'kana_rcpt2'}/;
	$footer =~ s/<!--postal_rcpt-->/$FORM{'postal_rcpt'}/;
	$footer =~ s/<!--pref_rcpt-->/$PREF{$FORM{'pref_rcpt'}}/;
	$footer =~ s/<!--address_rcpt-->/$FORM{'address_rcpt'}/;
	$footer =~ s/<!--address_rcpt2-->/$FORM{'address_rcpt2'}/;
	$footer =~ s/<!--tel_rcpt-->/$FORM{'tel_rcpt'}/;
}
else{
	$tb='<td>お客様情報と同じ</td>';
	$footer=~s/<!--rcpt-->.*<!--\/rcpt-->/$tb/si;
}


$info="";
$info.=qq(<input type="hidden" name="sessid" value="$FORM{'sessid'}">\n);
$info.=qq(<input type="hidden" name="name1" value="$FORM{'name1'}">\n);
$info.=qq(<input type="hidden" name="name2" value="$FORM{'name2'}">\n);
$info.=qq(<input type="hidden" name="kana1" value="$FORM{'kana1'}">\n);
$info.=qq(<input type="hidden" name="kana2" value="$FORM{'kana2'}">\n);
$info.=qq(<input type="hidden" name="postal" value="$FORM{'postal'}">\n);
$info.=qq(<input type="hidden" name="pref" value="$FORM{'pref'}">\n);
$info.=qq(<input type="hidden" name="address" value="$FORM{'address'}">\n);
$info.=qq(<input type="hidden" name="address2" value="$FORM{'address2'}">\n);
$info.=qq(<input type="hidden" name="tel" value="$FORM{'tel'}">\n);
$info.=qq(<input type="hidden" name="email" value="$FORM{'email'}">\n);
$info.=qq(<input type="hidden" name="email2" value="$FORM{'email2'}">\n);
$info.=qq(<input type="hidden" name="pay" value="$FORM{'pay'}">\n);
$info.=qq(<input type="hidden" name="deliver" value="$FORM{'deliver'}">\n);
$info.=qq(<input type="hidden" name="wrapping" value="$FORM{'wrapping'}">\n);
$info.=qq(<input type="hidden" name="postage" value="$postage_all">\n);
$info.=qq(<input type="hidden" name="cookie" value="$FORM{'cookie'}">\n);
$info.=qq(<input type="hidden" name="mel" value="$FORM{'mel'}">\n);
$info.=qq(<input type="hidden" name="pass" value="$FORM{'pass'}">\n);
$info.=qq(<input type="hidden" name="point" value="$FORM{'point'}">\n);
$info.=qq(<input type="hidden" name="pointnum" value="$FORM{'pointnum'}">\n);

if($FORM{'name_rcpt1'}){
	$info.=qq(<input type="hidden" name="name_rcpt1" value="$FORM{'name_rcpt1'}">\n);
	$info.=qq(<input type="hidden" name="name_rcpt2" value="$FORM{'name_rcpt2'}">\n);
	$info.=qq(<input type="hidden" name="kana_rcpt1" value="$FORM{'kana_rcpt1'}">\n);
	$info.=qq(<input type="hidden" name="kana_rcpt2" value="$FORM{'kana_rcpt2'}">\n);
	$info.=qq(<input type="hidden" name="postal_rcpt" value="$FORM{'postal_rcpt'}">\n);
	$info.=qq(<input type="hidden" name="pref_rcpt" value="$FORM{'pref_rcpt'}">\n);
	$info.=qq(<input type="hidden" name="address_rcpt" value="$FORM{'address_rcpt'}">\n);
	$info.=qq(<input type="hidden" name="address_rcpt2" value="$FORM{'address_rcpt2'}">\n);
	$info.=qq(<input type="hidden" name="tel_rcpt" value="$FORM{'tel_rcpt'}">\n);
}

if($FORM{'deliver_day'} eq "on"){
	$info.=qq(<input type="hidden" name="date" value="$FORM{'month'}月$FORM{'day'}日">\n);
}
else{
	$info.=qq(<input type="hidden" name="date" value="">\n);
}
if($FORM{'deliver_time'} eq "on"){
	$info.=qq(<input type="hidden" name="time" value="$FORM{'time'}">\n);
}
else{
	$info.=qq(<input type="hidden" name="time" value="">\n);
}
$info.=qq(<input type="hidden" name="message" value="$m_tmp">\n);

$footer =~ s/<!--info-->/$info/;

print <<EOM;
P3P: CP="UNI CUR OUR"
Content-type: text/html

EOM
print $head;
print ${$g_line_ref};
print $footer;

exit;

}



sub Order{
my(
$chk_mailbody,$mailbody,
$tax,$date,@waweek,$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,
$date_d,$time_d,$total,$subtotal,$a_total,$postage_all,$infoline,
$count,$dai_charge,$subtotal_c,$total_c,$postage_all_c,$tax_c,$dai_name,
$pointnum,$dai_charge_c,$wrap_charge_c,
$tax_all,$odrID,$dum,$day,$y_f,$mon_f,$mday_f,$line,
$tday,$sec_f,$ref,$wari,$nop,$goods_all_ref,$goods_all_kessai_ref,
$wari_c,$subtotal_o,$subtotal_o_c,$hour_f,%table
);


&filelock;

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$mon++;
$min=sprintf("%02d",$min);
$year=$year+1900;
$mon=sprintf("%02d",$mon);
$day=$mday;
$mday=sprintf("%02d",$mday);
$y_f=substr($year,2,2);
$mon_f=sprintf("%02d",$mon);
$mday_f=sprintf("%02d",$mday);

@waweek=('日','月','火','水','木','金','土');
$date="$year年$mon月$mday日($waweek[$wday]) $hour時$min分";
$date_d="$year/$mon/$mday";
$time_d="$hour:$min";

if($id == 1){
	unless(open(FILE,$countlog)){
		&error("$countlogが開けません。");
	}
	$line=<FILE>;
	close (FILE);
	($count)=split(/,/,$line);
	if($count eq ""){
		$count=0;
	}
	$count++;
	unless(open(FILE,">$countlog")){
		&error("$countlogに書き込みできません。");
	}
	print FILE "$count";
	close FILE;
	$odrID=sprintf("%0${digit}d",$count);

}
elsif($id == 2){
	unless(open(FILE,"$countlog")){
		&error("$countlogが開けません。");
	}
	$line=<FILE>;
	close (FILE);
	($count,$tday)=split(/,/,$line);
	if($count eq ""){
		$count=0;
	}
	if($tday == $day){
		$count++;
	}
	else{
		$tday=$day;
		$count=1;
	}
	$line="$count,$tday";
	unless(open(FILE,">$countlog")){
		&error("$countlogに書き込みできません。");
	}
	print FILE $line;
	close FILE;
	$odrID=$y_f.$mon_f.$mday_f.$count;
}
elsif($id==3){
	$hour_f=sprintf("%02d",$hour);
	$sec_f=sprintf("%02d",$sec);
	$odrID="$y_f$mon_f$mday_f$hour_f$min$sec_f$$";
}

if($id == 0){
	$odrID="";
}


if($id){
	$id="ご注文番号: $odrID\n";
}
else{
	$id="";
}

if($id_filename){
	$csvfile=$odrID;
}
if($id_title){
	$rcpt_mailsub.=" $odrID";
}


($ref)=&OpenData($FORM{'sessid'});

if(!${$ref}[0]){
	&error("商品がありません。");
}


$total=0;
$a_total=0;
$tax=0;
$tax_all=0;
$subtotal=0;
$postage_all=0;

($subtotal,$a_total,$tax_all,$postage_all,$dum,$dum,$wari,$nop,$goods_all_ref,$goods_all_kessai_ref)=&GoodsCal("",$ref);

$subtotal_o=$subtotal;
if($waribiki){
	$subtotal-=$wari;
	$wari_c=&Comma($wari);
}

($tax,$total)=&Tax($subtotal,$tax_all);
$postage_all=$FORM{'postage'};
$total+=$postage_all;

if($FORM{'wrapping'} eq "yes"){
	($wrap_charge,$total)=&Wrap($total,$subtotal);
	$wrap_charge_c=&Comma($wrap_charge);
}

if($dai_count_on){
	($dai_charge,$total,$dai_name)=&Dai($FORM{'pay'},$total,$subtotal);
	$dai_charge_c=&Comma($dai_charge);
}


$postage_all_c=&Comma($postage_all);
$tax_c=&Comma($tax);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$subtotal_o+=$tax if($zei==1);
$subtotal_o_c=&Comma($subtotal_o);
$total_c=&Comma($total);

if($postage==0 && $postage_alt){
	$postage_all_c=$postage_alt;
}

${$goods_all_ref}=~s/\n$//;

$mailbody=<<EOM;

============================================================
ご注文番号  : $odrID
ご注文日時  : $date_d
============================================================
EOM

$mailbody.=<<EOM;

■ご注文品
------------------------------------------------------------
${$goods_all_ref}

小計        :  $subtotal_o_c
EOM

if($waribiki){
$mailbody.=<<EOM;
割引        :  $wari_c
EOM
}

if($waribiki || $pointuse){
$mailbody.=<<EOM;
小計(割引後):  $subtotal_c
EOM
}

$mailbody.=<<EOM;
(うち消費税):  $tax_c
送料        :  $postage_all_c
EOM

if($dai_count_on){
$mailbody.=<<EOM;
手数料      :  $dai_charge_c
EOM
}

if($FORM{'wrapping'} eq "yes"){
$mailbody.=<<EOM;
ラッピング  :  $wrap_charge_c
EOM
}

$mailbody.=<<EOM;
----------------------------
合計        :  $total_c
EOM

%table=(
'－'=>'-',
);

if(index($FORM{'address'},'－') >= 0){
	$FORM{'address'}=~s/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xCD-\xDF][\x80-\xBF]|[\x00-\x7F])/defined($table{$1})? $table{$1} : $1/ge;
}
if(index($FORM{'address2'},'－') >= 0){
	$FORM{'address2'}=~s/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xCD-\xDF][\x80-\xBF]|[\x00-\x7F])/defined($table{$1})? $table{$1} : $1/ge;
}
if(index($FORM{'address_rcpt'},'－') >= 0){
	$FORM{'address_rcpt'}=~s/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xCD-\xDF][\x80-\xBF]|[\x00-\x7F])/defined($table{$1})? $table{$1} : $1/ge;
}
if(index($FORM{'address_rcpt2'},'－') >= 0){
	$FORM{'address_rcpt2'}=~s/([\xE0-\xEF][\x80-\xBF][\x80-\xBF]|[\xCD-\xDF][\x80-\xBF]|[\x00-\x7F])/defined($table{$1})? $table{$1} : $1/ge;
}

$mailbody.=<<EOM;

■ご注文者
お名前      :  $FORM{'name1'} $FORM{'name2'}
フリガナ    :  $FORM{'kana1'} $FORM{'kana2'}
郵便番号    :  $FORM{'postal'}
ご住所      :  $PREF{$FORM{'pref'}}$FORM{'address'}$FORM{'address2'}
お電話番号  :  $FORM{'tel'}
E-メール    :  $FORM{'email'}
EOM


if($FORM{'name_rcpt1'}){
$mailbody.=<<"EOM";

■お届け先
お名前      :  $FORM{'name_rcpt1'} $FORM{'name_rcpt2'}
フリガナ    :  $FORM{'kana_rcpt1'} $FORM{'kana_rcpt2'}
郵便番号    :  $FORM{'postal_rcpt'}
ご住所      :  $PREF{$FORM{'pref_rcpt'}}$FORM{'address_rcpt'}$FORM{'address_rcpt2'}
お電話番号  :  $FORM{'tel_rcpt'}
EOM
}
else{
$mailbody.=<<"EOM";

■お届け先
※ご注文者と同じ
EOM
}


$mailbody.=<<EOM;

■お支払い方法・配送方法
お支払い方法 :  $FORM{'pay'}
配送方法     :  $FORM{'deliver'}
EOM

if($FORM{'date'}){
$mailbody.=<<EOM;
希望配達日    :  $FORM{'date'}
EOM
}

if($FORM{'time'}){
$mailbody.=<<EOM;
希望配達時間  :  $FORM{'time'}
EOM
}

if($FORM{'wrapping'} eq "yes"){
$mailbody.=<<EOM;
ラッピング    :  あり
EOM
}


$mailbody.=<<EOM;

■要望など
$FORM{'message'}
EOM


if($tenp_pay){
	if($FORM{'pay'} eq '銀行振込'){
		$mailbody.=$paymsg_bank;
	}
	elsif($FORM{'pay'} eq '郵便振替'){
		$mailbody.=$paymsg_yu;
	}
	elsif($FORM{'pay'} eq '代金引換'){
		$mailbody.=$paymsg_dai;
	}
	elsif($FORM{'pay'} eq 'eコレクト'){
		$mailbody.=$paymsg_e;
	}
	elsif($FORM{'pay'} eq 'クロネコペイメント'){
		$mailbody.=$paymsg_kuro;
	}

}




$email_style1="$FORM{'name1'}  様\n\n".$email_style1;

$chk_mailbody=$email_style1.$mailbody.$email_style2;

$mailbody.="\n";
$mailbody.="IP address : $ENV{'REMOTE_ADDR'}\n";
$mailbody.="Host      : $ENV{'REMOTE_HOST'}\n";
$mailbody.="User Agent: $ENV{'HTTP_USER_AGENT'}\n";


if($zaiko){
	&After($ref);
}

unless(-e $mailpl){
	&error("lib/mail.plがありません。");
}
require $mailpl;

&S_Mail($mailto,$FORM{'email'},$FORM{'name1'},$rcpt_mailsub,$mailbody,"shop",$ref,$odrID,$a_total,$subtotal,$tax,$total,$date_d,$time_d);
&S_Mail($FORM{'email'},$mailto,$shop,$chk_mailsub,$chk_mailbody,"","");
if($mailto2){
	&S_Mail($mailto2,$FORM{'email'},$FORM{'name1'},$rcpt_mailsub,$mailbody,"shop",$ref);
}

&CookieDel($c_name);

&LogClear;


if($FORM{'cookie'} eq "on"){
	if($pd eq ""){
		&error("パスワードが設定されていません。");
	}

	$infoline="$FORM{'name1'},$FORM{'name2'},$FORM{'kana1'},$FORM{'kana2'},$FORM{'postal'},$FORM{'pref'},$FORM{'address'},$FORM{'address2'},$FORM{'tel'},$FORM{'email'}";
	$infoline=&Encrypt($infoline);
	&SetCookieAn($infoline,$angoc_name);
}



if($lockflag==1){
	close LOCK;
}

$pointnum=0;

&End($pointnum,$FORM{'pay'},$odrID,${$goods_all_kessai_ref},$total,"$FORM{'name1'}$FORM{'name2'}",$FORM{'tel'},$FORM{'email'});

}



sub After{
my(
$no,$na,$stock,$opt,$opst,
$n,
$num,$name,$d,$amount,$op,
@opst_a,@opt_a,$opline1,
$opline2,@o1,@o2,$k,$flag,$s,@o,$v,@new,
$l,$g_name,@s,$sold,$i,$ref,$idx,$opt
);

$ref=$_[0];
$idx=0;
unless(open(FILE,$g_log)){
	&error("$g_logが開けません。");
}
while(<FILE>){
	($no,$na,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$opt,$opst)=split(/,/,$_);
	foreach $n(@{$ref}){
		($num,$name,$d,$amount,$d,$d,$d,$d,$d,$d,$op)=split(/,/,$n);
		($num)=split(/__/,$num);
		if($no eq $num){
			if($opt eq ""){
				if($stock == 0){
					&error("大変申し訳ありません。$nameは先に注文があり、在庫切れになりました。下のリンクよりお戻りになり、商品を削除して再度ご注文ください。","b");
				}
				if($amount > $stock){
					&error("大変申し訳ありません。$nameはただいまご注文があり、ご注文数より在庫が少なくなりました。現在の在庫数は$stockです。下のリンクよりお戻りになり、個数を変更して再度ご注文ください。","b");
				}
				$stock-=$amount;
				if($stock < 0){
					$stock=0;
				}
			}
			else{
				$opst.=":d";
				@opst_a=split(/:/,$opst);
				pop @opst_a;
				@opt_a=split(/<>/,$opt);
				$n=@opt_a;
				$opline1=$opt_a[0];
				$opline2=$opt_a[1];
				if($n==2){
					@o1=();
					if($opline1){
						$opline1.=":d";
						@o1=split(/:/,$opline1);
						pop @o1;
					}
					@o2=();
					if($opline2){
						$opline2.=":d";
						@o2=split(/:/,$opline2);
						pop @o2;
					}
					$k=0;
					$flag=0;
					foreach $v(@o1){
						foreach $l(@o2){
							$s=$v.":".$l;
							if($s eq $op){
								$flag=1;
								last;
							}
							$k++;
						}
						if($flag){
							last;
						}
					}
					if(($k <= $#opst_a) && ($opst_a[$k] ne "")){
						if($opst_a[$k] == 0){
							&error("大変申し訳ありません。$g_nameの$v $lは先に注文がありました。下のリンクよりお戻りになり、商品を削除して、再度ご注文ください","modify");
						}
						if($amount > $opst_a[$k]){
							&error("申し訳ございませんが、$g_nameの$v $lはただ今注文があり、ご注文数より在庫が少なくなりました。現在の在庫数は$s[$i]です。下のリンクよりお戻りになり、商品を削除して、再度ご注文ください","modify");
						}
						$opst_a[$k]-=$amount;
						if($opst_a[$k]<0){
							$opst_a[$k]=0;
						}
						if($opst_a[$k]==0){
							$sold="$g_nameの$v $lが売り切れました。";
						}
					}
					$opst=join(":",@opst_a);
				}
				elsif($n==1){
					@o=();
					if($opline1){
						$opline1.=":d";
						@o=split(/:/,$opline1);
						pop @o;
					}
					$k=0;
					$flag=0;
					foreach $v(@o){
						if($v eq $op){
							$flag=1;
							last;
						}
						$k++;
					}
					if(($k <= $#opst_a) && ($opst_a[$k] ne "")){
						if($opst_a[$k] == 0){
							&error("大変申し訳ありません。$g_nameの$vは先に注文がありました。下のリンクよりお戻りになり、商品を削除して、再度ご注文ください","modify");
						}
						if($amount > $opst_a[$k]){
							&error("申し訳ございませんが、$g_nameの$vはただ今注文があり、ご注文数より在庫が少なくなりました。現在の在庫数は$s[$i]です。下のリンクよりお戻りになり、商品を削除して、再度ご注文ください","modify");
						}
						$opst_a[$k]-=$amount;
						if($opst_a[$k]<0){
							$opst_a[$k]=0;
						}
						if($opst_a[$k]==0){
							$sold="$g_nameの$vが売り切れました。";
						}
					}
					$opst=join(":",@opst_a);
				}
			}
			$_="$no,$na,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$opt,$opst,\n";
		}
	}
	$new[$idx]=$_;
	$idx++;

}
close FILE;

unless(open(FILE,">$g_log")){
	&error("$g_logが開けません。")
}
print FILE @new;
close FILE;

&MakeJs(\@new);

}

sub MakeJs{
my(
$ref,
$no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst,
$tmp,@op,@opst,$i,@o,$oline1,$oline2,
$l,$v,$t,@o1,@o2,$dum
);

$ref=$_[0];

unless(open(FILE,">$jslog")){
	&error("$jslogが開けません。");
}
print FILE "var st=new Array();\n";
foreach(@{$ref}){
	($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst)=split(/,/,$_);
	if(($op ne "") || ($opst ne "")){
		if($op=~/\//){
			($dum,$op)=split(/\//,$op);
		}
		@op=split(/<>/,$op);
		@opst=split(/:/,$opst);
		$tmp="";
		$tmp.="st['$no']=new Array()\;\n";
		$i=0;
		if(@op == 1){
			@o=split(/:/,$op);
			foreach $v(@o){
				$tmp.="st['$no']['$v']='$opst[$i]'\;\n";
				$i++;
			}
		}
		elsif(@op == 2){
			@o=split(/<>/,$op);
			$oline1=$o[0];
			$oline2=$o[1];
			$oline1.=':d';
			$oline2.=':d';
			@o1=split(/:/,$oline1);
			@o2=split(/:/,$oline2);
			pop @o1;
			pop @o2;
			$i=0;
			foreach $l(@o1){
				foreach $v(@o2){
					$t="$l $v";
					if($opst[$i] ne ""){
						$tmp.="st['$no']['$t']='$opst[$i]'\;\n";
					}
					$i++;

				}
			}
		}
	}
	else{
		$tmp="st[\"$no\"]=\"$stock\"\;\n";
	}
	print FILE $tmp;
}

close FILE;


}


sub LogClear{
my($bango,$flag,$id,$time,$now,@alltmp,$checkflag,$limit,$idx);
$now=time;
$bango=$FORM{'sessid'};
unless(open(TMP,$tmplog)){
	&error("$tmplogが開けません。");
}
$checkflag=0;
$limit=24*60*60;
$idx=0;
while(<TMP>){
	$flag=0;
	($id,$time)=split(/<>/,$_);
	if($id eq $bango){
		$checkflag=1;
		$flag=1;
	}
	if(($now-$time) > $limit){
		$flag=1;
	}
	if(!$flag){
		$alltmp[$idx]=$_;
		$idx++;
	}

}
#if(!$checkflag){
#	&error("idがありません。ブラウザを閉じてもう一度購入してください。");
#}
close TMP;


unless(open(TMP,">$tmplog")){
	&error("$tmplogに書き込めません");
}
print TMP @alltmp;
close TMP;

}


sub Encrypt{
my($data,$len,$len_p,@ran,$j,$i,$tmp,$d,$tmp_p,$d_p,$dum,$r,$result,$sal);

$data=$_[0];
$len=length($data);
$len_p=length($pd);

$sal=0;
for($i=0;$i<$len_p;$i++){
	$tmp_p=substr($pd,$i,1);
	$sal+=unpack("C",$tmp_p);
}
srand($sal);
$sal=int(rand(10000));

srand($sal);

for($i=0;$i<$len_p;$i++){
	$ran[$i]=int(rand(127));
}

$j=0;
for($i=0;$i<$len;$i++){
	$tmp=substr($data,$i,1);
	$d=unpack("C",$tmp);
	$tmp_p=substr($pd,$j,1);
	$d_p=unpack("C",$tmp_p);
	$dum=$d_p ^ $ran[$j];
	$r=$d ^ $dum;
	$result.=pack("C",$r);
	$j++;
	if($j >= $len_p){
		$j=0;
	}
}

$result=unpack("H*",$result);

return($result);
}

sub Decrypt{
my($data,$len,$len_p,@ran,$j,$i,$tmp,$d,$tmp_p,$d_p,$dum,$r,$result,$sal);

$data=$_[0];

$data=pack("H*",$data);

$len=length($data);
$len_p=length($pd);

$sal=0;
for($i=0;$i<$len_p;$i++){
	$tmp_p=substr($pd,$i,1);
	$sal+=unpack("C",$tmp_p);
}
srand($sal);
$sal=int(rand(10000));
srand($sal);
for($i=0;$i<$len_p;$i++){
	$ran[$i]=int(rand(127));
}

$j=0;
for($i=0;$i<$len;$i++){
	$tmp=substr($data,$i,1);
	$d=unpack("C",$tmp);
	$tmp_p=substr($pd,$j,1);
	$d_p=unpack("C",$tmp_p);
	$dum=$d_p ^ $ran[$j];
	$r=$d ^ $dum;
	$result.=pack("C",$r);
	$j++;
	if($j >= $len_p){
		$j=0;
	}
}

return $result;
}


sub End{
my($skinline,@goods,$tmpline,$line,$kessai,$odrID);

$_[3]=~s/:$//;
@goods=split(/:/,$_[3]);
$odrID=$_[2];
$tmpline="";
$line="";
foreach(@goods){
	$tmpline.=$_;
	if(length($tmpline) >= 170){
		$line.="・・・";
		last;
	}
	$line=$tmpline;
}

unless(open(HTML, $thanks)){
	&error("$thanksが開けません。ファイル名を確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);
if($id){
	$skinline =~ s/<!--id-->/お客様のご注文番号は$odrIDです。<br>/;
}

if($_[1] eq "クロネコWEBコレクト"){
$kessai=<<EOM;
<div align="center">
<form name="UserForm" action="https://payment.kuronekoyamato.co.jp/kuroneko/servlet/YCS_ServletC" method="post" target="_blank">
<input type="hidden" name="TRS_MAP" value="L_TEST">
<input type="hidden" name="trader_code" value="$trader_code">
<input type="hidden" name="order_no" value="$_[2]">
<input type="hidden" name="goods_name" value="$line">
<input type="hidden" name="settle_price" value="$_[4]">
<input type="hidden" name="buyer_name_kanji" value="$_[5]">
<input type="hidden" name="buyer_tel" value="$_[6]">
<input type="hidden" name="buyer_email" value="$_[7]">
<input type="submit" value="クロネコWEBコレクトでの決済はこちら">
</form>
</div>
EOM
$skinline=~s/<!--kessai-->/$kessai/;
}

print <<EOM;
P3P: CP="UNI CUR OUR"
Content-type: text/html

EOM

print $skinline;

exit;
}


sub error{

if($lockflag==1){
	close LOCK;
}

print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<style type="text/css">
td,p{font-size:10pt}
a{color:#0000ff}
</style>
</head>
<body>
<br>
<br>
<div align="center">ERROR</div>
<hr width="320" noshade size="1" color="#bebebe">
<table width=346 align=center><tr><td align=center>
EOM
print"※$_[0]\n";
if($_[1] eq "b"){
print qq(<br><br><a href="cart.cgi?mode=view">カート画面で変更</a>);
}
elsif($_[1] eq "c"){
print qq(<br><br><a href="#" onclick="history.back()">商品画面に戻る</a>);
}
else{
	if($_[1] ne "r"){
		print qq(<br><br>ブラウザの戻るボタンでお戻りください。);
	}
}
print <<EOM;
</td></tr></table>
</body>
</html>
EOM
exit;
}
exit;
